library(stockassessment)
load("run/model.RData")
FC<-list()

#2022 forecast
#F=0
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,0,0), fval=c(0.382,0.382,NA,NA), label="2020F=2021F then zero", rec.years=1973:2020)

#Fmsy
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(0.382,0.382,0.40,0.40), label="2020F=2021F then Fmsy", #rec.years=1973:2020)

#F=SQ
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(0.382,0.382,0.382,0.382), label="SQ, 2020F=2021F", #rec.years=1973:2020)

#F that will get us to Blim
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fval=c(0.382,0.382,NA,0.268), fscale=c(NA,NA,NA,NA), nextssb=c(NA,NA,10354,NA),label="2020F=2021F #SSB(2022)= Blim")

#F that will get us to Bpa and in this case MSYBtrigger
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fval=c(0.382,0.382,NA,0.268), fscale=c(NA,NA,NA,NA), nextssb=c(NA,NA,14803,NA),label="2020F=2021F #SSB(2022)= Bpa")

#Flim in 2022
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fval=c(0.366,0.366,2.34,2.34), fscale=c(NA,NA,NA,NA), label="2020F=2021F Flim(2022)")

#Fpa in 2022
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fval=c(0.366,0.366,1.33,1.33), fscale=c(NA,NA,NA,NA), label="2020F=2021F Fpa(2022)")


# 2023  TAC2022
# Fmsy
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fval=c(.529,NA,.29,.29), catchval=c(NA,27430,NA,NA),label="2021+TAC2022 then Fmsy", rec.years=1973:2021)

# Fpa
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fval=c(.529,NA,0.65,0.65),catchval=c(NA,27430,NA,NA),label="2021+TAC2022 then Fpa", rec.years=1973:2021)

# Flim
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fval=c(.529,NA,1.98,1.98),catchval=c(NA,27430,NA,NA), label="2021+TAC2022 then Flim", rec.years=1973:2021)

# SQ 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fval=c(0.529,NA,0.995,0.995),catchval=c(NA,27430,NA,NA), label="2021+TAC2022 then SQ", rec.years=1973:2021)

# F=0
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fval=c(.529,NA,NA,NA), catchval=c(NA,27430,NA,NA), fscale=c(NA,NA,0,0), label="2021+TAC2022 then F=0", rec.years=1973:2021)

# SSB(2023)=Blim
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, catchval=c(NA,27430,NA,NA),fval=c(.529,NA,NA,.29), nextssb=c(NA,NA,11738,NA),label="TAC2022+SSB(2024)= Blim",rec.years=1973:2021)

# SSB(2023)=Bpa
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, catchval=c(NA,27430,NA,NA), fval=c(.529,NA,NA,.29), nextssb=c(NA,NA,18146,NA),label="TAC2022+SSB(2024)= Bpa",rec.years=1973:2021)

save(FC, file="run/forecast.RData")
